import 'package:ngex/ngex.dart';
import 'package:ngex/store.interface.dart';

class Store extends NgexStore {
  final counter = StoreValue<int>(10);
  final list = StoreValue<List<int>>([]);
  final index = StoreValue<int>(0);

  void increment() {
    counter.value++;
  }

  void addElement() {
    list.value.add(index.value++);
    list.notify();
  }

  void watchTest() {
    // index.watch((s) => print("-> ${s}"));
  }

  void reset() {
    counter.value = 0;
    list.value.clear();
    list.notify();
  }

  void dispose() {
    counter.dispose();
    list.dispose();
    index.dispose();
  }
}
