import 'package:flutter/widgets.dart';

class Notification extends ChangeNotifier {
  void notify() {
    notifyListeners();
  }
}

class StoreValue<T> {
  StoreValue(T initialValue) : super() {
    _value = initialValue;
  }

  late T _value;
  final Notification _s = Notification();
  ChangeNotifier get listen => _s;

  T get value => _value;

  set value(T value) {
    if (_value != value) {
      _value = value;
      notify();
    }
  }

  void dispose() => _s.dispose();
  void notify() => _s.notify();
  void watch(Function(T) callback) => _s.addListener(() => callback(_value));
}
